"use strict";

// Generated by CoffeeScript 2.4.1
(function () {
  var Promise, _, sinon;

  _ = require("lodash");

  sinon = require("sinon");

  Promise = require("bluebird");

  sinon.usingPromise(Promise);

  module.exports = {
    createContextReaderProcessor: function createContextReaderProcessor(clazz) {
      var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var items, processor, stubs;
      _.defaults(opts, {
        connection: {
          url: "urlConnection",
          key: "keyConnection"
        }
      });
      processor = new clazz(opts);
      items = [{
        id: 1,
        resource: 123,
        notification: JSON.stringify({
          ResourceId: 123
        })
      }, {
        id: 2,
        resource: 234,
        notification: JSON.stringify({
          ResourceId: 234
        })
      }];
      stubs = {
        "search": sinon.stub(processor.search, "find").resolves({
          count: 2,
          items: items
        }),
        "delete": sinon.stub(processor.search, "remove").resolves()
      };
      return { processor: processor, stubs: stubs };
    }
  };
}).call(undefined);